﻿Enumeration
  #ca
EndEnumeration

Enumeration ;modes
  #mode_non
  #mode_drw
  #mode_cir
  #mode_fill
EndEnumeration

Global canundo.l=0
Global col.l=15
Global dmode.l
Global Dim ac.l(16)
Global *m=AllocateMemory(1024*3)

Global Dim lra.l(48)
Global ver$="Apple ][ lores paint 0.2"

Global tosave.s=""
CopyMemory(?alogo,*m,1024)

Procedure initvars()
  ; BLACK........#000000 -0
  ac(0)=RGB(0,0,0)
  ; MAGENTA......#CC0033 - 1
  ac(1)=RGB($CC,0,$33)
  ; DARK BLUE....#000099 -2
  ac(2)=RGB(0,0,$99)
  ; PURPLE.......#CC33CC -3
  ac(3)=RGB($CC,$33,$CC)
  ; DARK GREEN...#006633 -4
  ac(4)=RGB($00,$66,$33)
  ; DARK GREY....#666666 -5
  ac(5)=RGB($66,$66,$66)
  ; MED. BLUE....#3333FF -6
  ac(6)=RGB($33,$33,$FF)
  ; LIGHT BLUE...#6699FF -7
  ac(7)=RGB($66,$99,$FF)
  ; BROWN........#996600 -8
  ac(8)=RGB($99,$66,$00)
  ; ORANGE.......#FF6600 -9
  ac(9)=RGB($FF,$66,$00)
  ; LIGHT GREY...#999999 -10
  ac(10)=RGB($99,$99,$99)
  ; PINK.........#FF9999 -11
  ac(11)=RGB($FF,$99,$99)
  ; LIGHT GREEN..#00CC00 -12
  ac(12)=RGB($00,$CC,$00)
  ; YELLOW.......#FFFF00 -13
  ac(13)=RGB($FF,$FF,$00)
  ; AQUA.........#33FF99 -14
  ac(14)=RGB($33,$FF,$99)
  ; WHITE........#FFFFFF -15
  ac(15)=RGB($FF,$FF,$FF)
  
  ;calc adresses
  
  For y=0 To 48
    ; F847: 48        141  GBASCALC PHA              ;FOR INPUT 000DEFGH
    ; F848: 4A        142           LSR
    ; F849: 29 03     143           And   #$03
    ; F84B: 09 04     144           ORA   #$04       ;  GENERATE GBASH=000001FG
    ; F84D: 85 27     145           STA   GBASH
    GBASH.a = ((y>>1)&3);|4
    
    ; F84F: 68        146           PLA              ;  AND GBASL=HDEDE000
    ; F850: 29 18     147           And   #$18
    ; F852: 90 02     148           BCC   GBCALC
    ; F854: 69 7F     149           ADC   #$7F
    ; F856: 85 26     150  GBCALC   STA   GBASL
    If y&1
      GBASL.a=y&$18+128
    Else
      GBASL=y&$18
    EndIf
    ; F858: 0A        151           ASL
    ; F859: 0A        152           ASL
    ; F85A: 05 26     153           ORA   GBASL
    ; F85C: 85 26     154           STA   GBASL
    GBASL=GBASL|(GBASL<<2)
    ; F85E: 60        155           RTS
    lra(y)=GBASH*256+GBASL
  Next y
  
EndProcedure

Procedure drawpic()
  StartDrawing(CanvasOutput(#ca))
  For y=0 To 47
    For x=0 To 39
      c.a=PeekA(*m+lra(y)+x)
      Box (x*16,y*16,16,8,ac(c&15))
      Box (x*16,8+y*16,16,8,ac(c>>4))
    Next x
  Next y
  x = Int(GetGadgetAttribute(#ca, #PB_Canvas_MouseX)/16)*16
  y = Int(GetGadgetAttribute(#ca, #PB_Canvas_MouseY)/8)*8
  Box (x,y,16,8,ac(col))
  StopDrawing()
EndProcedure

Procedure dot(x,y,co)
  ;y&1=0, c
  ;y&1=1, c<<4
  ;Debug x
  If y>=0 And y<=47
    If x>=0 And x<=39
      yy=y/2
      c.a=PeekA(*m+lra(yy)+x)
      If y&1
        c=(c&15)|(co<<4)
      Else
        c=(c&240)|co
      EndIf
      
      PokeA(*m+lra(yy)+x,c)
    EndIf;x
  EndIf  ;y
  
EndProcedure

Procedure DrawLine(x0.w,y0.w,x1.w,y1.w)
  ;  Local e,e2,x,y,dx,dy,sx,sy,D As Long
  dx.w = Abs(x1-x0)
  dy.w = Abs(y1-y0)
  sx.w=Sign(x1-x0);If x0 < x1 Then sx=1 Else sx=-1
  sy.w=Sign(y1-y0);If y0 < y1 Then sy=1 Else sy=-1
  e.w = dx-dy
  
  drwlp:
  dot(x0,y0,col)
  If x0 = x1 And y0 = y1:Goto ex_dr:EndIf; Then Exit Loop
  e2.w = 2*e
  If e2 > -dy
    e = e - dy
    x0 = x0 + sx
  EndIf
  
  If e2 <  dx
    e = e + dx
    y0 = y0 + sy
  EndIf
  Goto drwlp
  ex_dr:
EndProcedure

Procedure plotCircle(xm.l,ym.l,r.l);void plotCircle(int xm, int ym, int r)
                                   ; {
                                   ;    int x = -r, y = 0, err = 2-2*r; /* II. Quadrant */ 
  x.l=-r
  y.l=0
  err.l=0
  While x<0;    do {
    dot(xm-x,ym+y,col);       setPixel(xm-x, ym+y); /*   I. Quadrant */
    dot(xm-y,ym-x,col);       setPixel(xm-y, ym-x); /*  II. Quadrant */
    dot(xm+x,ym-y,col);       setPixel(xm+x, ym-y); /* III. Quadrant */
    dot(xm+y,ym+x,col);       setPixel(xm+y, ym+x); /*  IV. Quadrant */
    rr.l=err          ;       r = err;
                      ;       If (r <= y) err += ++y*2+1;           /* e_xy+e_y < 0 */
    If rr<=y
      y+1
      err=err+1+2*y
    EndIf
    ;       If (r > x || err > y) err += ++x*2+1; /* e_xy+e_x > 0 or no 2nd y-step */
    If rr>x Or err>y
      x+1
      err=err+1+2*x
    EndIf
    
  Wend;    } While (x < 0);
      ;      }
EndProcedure

Procedure.a scrn(x,y)
  yy=y/2
  c.a=PeekA(*m+lra(yy)+x)
  If y&1
    c=(c&240)>>4
  Else
    c=c&15
  EndIf
  ProcedureReturn c
EndProcedure

;bug : ce<>cc and it's works
Procedure fill(x.l,y.l,ce.l,cc.l)
  If x>=0 And x<40 And y>=0 And y<48; And scrn(x,y)=ce
    If scrn(x,y)=ce
      dot(x,y,cc)
      fill(x-1,y,ce,cc)
      fill(x+1,y,ce,cc)
      fill(x,y+1,ce,cc)
      fill(x,y-1,ce,cc)
    EndIf
  EndIf
EndProcedure

Procedure resetbut(n.l)
  For i=0 To 23
    SetToolBarButtonState(0, i, #PB_ToolBar_Normal)
  Next i
  SetToolBarButtonState(0, n, #PB_ToolBar_Toggle)
EndProcedure

Procedure writefile()
  If CreateFile(0,tosave)
    If Not WriteData(0,*m,1024)
      MessageRequester("Error", "Read file:"+tosave, 0) 
    EndIf
    CloseFile(0)
  Else
    MessageRequester("Error", "Read file:"+tosave, 0) 
  EndIf
EndProcedure

Procedure writepic()
  StandardFile$ = GetCurrentDirectory()+"\image1.png";"C:\autoexec.bat"   ; set initial file+path to display
  Pattern$ = "Portable Network Graphics(*.png)|*.png"
  Pattern = 0    ; use the first of the three possible patterns as standard
  File$ = OpenFileRequester("Please choose file to save", StandardFile$, Pattern$, Pattern)
  If File$
    UsePNGImageEncoder()
    CreateImage(200,640,48*8)
    StartDrawing(ImageOutput(200))
    For y=0 To 47
      For x=0 To 39
        c.a=PeekA(*m+lra(y)+x)
        Box (x*16,y*16,16,8,ac(c&15))
        Box (x*16,8+y*16,16,8,ac(c>>4))
      Next x
    Next y
    StopDrawing()
    If Not SaveImage(200,File$,#PB_ImagePlugin_PNG)
    EndIf
  EndIf
  FreeImage(200)
  
EndProcedure

initvars()
dmode=#mode_non

If OpenWindow(0, 0, 0, 640, 440, ver$, #PB_Window_SystemMenu | #PB_Window_ScreenCentered|#PB_Window_MinimizeGadget)
  ;CanvasGadget(#ca, 24, 30, 280*2+40, 192*2)
  CanvasGadget(#ca, 0, 30, 640, 48*8);192*2)
  
  ;---------------------------------------------------
  For i=0 To 15
    CreateImage(i,16,16)
    StartDrawing(ImageOutput(i))
    Box(0,0,16,16,ac(i))
    StopDrawing()
  Next i
  
  If CreateToolBar(0, WindowID(0))
    ToolBarStandardButton(16, #PB_ToolBarIcon_New)
    ToolBarToolTip(0, 16, "New document")
    ToolBarStandardButton(17, #PB_ToolBarIcon_Open)
    ToolBarToolTip(0, 17, "Open document")
    ToolBarStandardButton(18, #PB_ToolBarIcon_Save)
    ToolBarToolTip(0, 18, "Save document")
    
    ToolBarSeparator()
    
    For i=0 To 15
      ToolBarImageButton(i,ImageID(i))
      ToolBarToolTip(0, i, "color # : "+Str(i))
    Next i
    ToolBarSeparator()
    
    CatchImage(16,?imgline)
    ToolBarImageButton(19,ImageID(16),#PB_ToolBar_Toggle)
    ToolBarToolTip(0, 19, "line draw")
    
    CatchImage(17,?imgcir)
    ToolBarImageButton(20,ImageID(17),#PB_ToolBar_Toggle)
    ToolBarToolTip(0, 20, "circle")
    
    CatchImage(18,?imgfill)
    ToolBarImageButton(21,ImageID(18),#PB_ToolBar_Toggle)
    ToolBarToolTip(0, 21, "color fill")
    
    CatchImage(20,?imgpen)
    ToolBarImageButton(23,ImageID(20),#PB_ToolBar_Toggle)
    ToolBarToolTip(0, 23, "pen")
    
    CatchImage(19,?imgundo)
    ToolBarImageButton(22,ImageID(19));,#PB_ToolBar_Toggle)
    ToolBarToolTip(0, 22, "undo")
  EndIf
  ;---------------------------------------------------
  If CreatePopupMenu(1)
    OpenSubMenu("Color")
    For i=0 To 15
      MenuItem(i, "color #"+Str(i))
    Next i
    CloseSubMenu()
    MenuBar()
    MenuItem(24, "Save As..")
    MenuItem(25, "Export picture...")
    MenuBar()
    MenuItem(19, "Draw")
    MenuItem(20, "circle")
    MenuItem(21, "color fill")
    MenuItem(23, "pen")
    OpenSubMenu("Scroll")
    MenuItem(26, "scroll left")
    MenuItem(27, "scroll right")
    MenuItem(28, "scroll up")
    MenuItem(29, "scroll down")
    CloseSubMenu()
  EndIf
  ;---------------------------------------------------
  
  ;col=15
  ;plotCircle(19,22,21)
  drawpic()
  
  Repeat
    Event = WaitWindowEvent()
    If GetAsyncKeyState_(#VK_ESCAPE)=-32767
      Break
    EndIf
    
    Select event
      Case #PB_Event_Menu
        cm.l=EventMenu()
        Select cm
          Case 26:;scroll left
            For y=0 To 47
              For x=1 To 39
                dot(x-1,y,scrn(x,y))
              Next x
            Next y
            drawpic()
          Case 27:;scroll right
            For y=0 To 47
              For x=39 To 1 Step -1
                dot(x,y,scrn(x-1,y))
              Next x
            Next y
            drawpic()
          Case 28:;scroll up
            For y=1 To 47
              For x=0 To 39
                dot(x,y-1,scrn(x,y))
              Next x
            Next y
            drawpic()
            
          Case 29:;scroll down
            For y=47 To 1 Step -1
              For x=0 To 39
                dot(x,y,scrn(x,y-1))
              Next x
            Next y
            drawpic()
          Case 0 To 15: col=cm
          Case 16: ; New
            FillMemory(*m,1024,0)
            drawpic()
            tosave=""
          Case 17: ; Open
            StandardFile$ = GetCurrentDirectory()+"\pic#060400"
            File$ = OpenFileRequester("Please choose file to load", StandardFile$, "All files (*.*)|*.*", 0)
            If File$
              tosave=File$
              If ReadFile(0,File$)
                If Not ReadData(0,*m,1024)
                  MessageRequester("Error", "Read file:"+File$, 0) 
                EndIf
                CloseFile(0)
              Else
                MessageRequester("Error", "Read file:"+File$, 0) 
              EndIf
            EndIf
          Case 18: ; Save
            If tosave=""
              StandardFile$ = GetCurrentDirectory()+"\pic#060400"
              File$ = OpenFileRequester("Please choose file to save", StandardFile$, "All files (*.*)|*.*", 0)
              If File$
                tosave=File$
                writefile()
              EndIf
            Else
              writefile()
            EndIf
            
          Case 19: ; DrawLine
            dmode=#mode_drw
            x00=-1
            y00=-1
            resetbut(19)
          Case 20: ; Draw circle
            dmode=#mode_cir
            xr0=-1
            yr0=-1
            resetbut(20)
          Case 21: ; fill
            dmode=#mode_fill
            resetbut(21)
          Case 22:
            If canundo
              canundo=0
              CopyMemory(*m+2048,*m,1024)
              drawpic()
            EndIf
          Case 24: ;Save As
            StandardFile$ = GetCurrentDirectory()+"\pic#060400"
            File$ = OpenFileRequester("Please choose file to save", StandardFile$, "All files (*.*)|*.*", 0)
            If File$
              tosave=File$
              writefile()
            EndIf
          Case 25: ;Export picture
            writepic()
            
          Case 23:
            dmode=#mode_non
            resetbut(23)
        EndSelect
        
      Case #PB_Event_Gadget
        If EventGadget() = #ca
          
          If EventType()=#PB_EventType_RightButtonDown
            ;Debug "rc"
            DisplayPopupMenu(1, WindowID(0) )
          EndIf
          
          If EventType() = #PB_EventType_LeftButtonDown Or (EventType() = #PB_EventType_MouseMove)
            
            x = Int(GetGadgetAttribute(#ca, #PB_Canvas_MouseX)/16);*16
            y = Int(GetGadgetAttribute(#ca, #PB_Canvas_MouseY)/8) ;*8
            SetWindowTitle(0,ver$+" x:"+Str(x)+",y:"+Str(y) )
            If GetGadgetAttribute(0, #PB_Canvas_Buttons) & #PB_Canvas_LeftButton
              
              Select dmode
                Case #mode_fill
                  ba=scrn(x,y)
                  If ba=col
                    MessageRequester("Error", "Can't fill area with color. Try another one", 0)
                  Else
                    canundo=1
                    CopyMemory(*m,*m+2048,1024)
                    fill(x,y,ba,col)
                    drawpic()
                  EndIf
                  
                Case #mode_cir
                  If xr0=-1 And yr0=-1
                    xr0=x
                    yr0=y
                    drawpic()
                  Else
                    canundo=1
                    CopyMemory(*m,*m+2048,1024)
                    
                    rr=Int( Sqr( (x-xr0)*(x-xr0) +(y-yr0)*(y-yr0) ) )
                    plotCircle(xr0,yr0,rr)
                    drawpic()
                    xr0=-1
                    yr0=-1
                    
                  EndIf  
                Case #mode_drw
                  If x00=-1 And y00=-1
                    x00=x
                    y00=y
                    drawpic()
                  Else
                    canundo=1
                    CopyMemory(*m,*m+2048,1024)
                    drawline(x00,y00,x,y)
                    drawpic()
                    ;dmode=#mode_non
                    x00=-1
                    y00=-1
                  EndIf  
                Case #mode_non
                  dot(x,y,col)
                  drawpic()
              EndSelect
              
            Else
              Select dmode
                Case #mode_fill
                  drawpic()
                Case #mode_cir
                  If xr0<>-1 And yr0<>-1
                    CopyMemory(*m,*m+1024,1024)
                    ;                  drawline(x00,y00,x,y)
                    rr=Int( Sqr( (x-xr0)*(x-xr0) +(y-yr0)*(y-yr0) ) )
                    plotCircle(xr0,yr0,rr)
                    drawpic()
                    CopyMemory(*m+1024,*m,1024)
                  Else
                    drawpic()
                  EndIf
                  
                Case #mode_drw
                  If x00<>-1 And y00<>-1
                    CopyMemory(*m,*m+1024,1024)
                    drawline(x00,y00,x,y)
                    drawpic()
                    CopyMemory(*m+1024,*m,1024)
                  Else
                    drawpic()
                  EndIf
                Case #mode_non
                  drawpic()
              EndSelect
            EndIf
            
          EndIf;EventType() = #PB_EventType_LeftButtonDown
        EndIf
    EndSelect
    
  Until Event = #PB_Event_CloseWindow
EndIf

FreeMemory(*m)

DataSection
  alogo:
  IncludeBinary "ALOGO_#060400"
  imgline:
  IncludeBinary "line.bmp"
  imgcir:
  IncludeBinary "cir.bmp"
  imgfill:
  IncludeBinary "fill.bmp"
  imgundo:
  IncludeBinary "undo.bmp"
  imgpen:
  IncludeBinary "pen.bmp"
  
EndDataSection
; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 380
; FirstLine = 378
; Folding = --
; EnableUnicode
; EnableXP
; UseIcon = apple 2.ico
; Executable = lorespa.exe